package edu.toronto.cs.ctl;

/**
 ** This is a universal strong until CTL node.
 **/
public class CTLAUiNode extends CTLAUNode
{

  protected int bound;

  /**
   ** Construct a bounded universal strong until CTL node using two
   ** other nodes as its children.
   **/
  protected CTLAUiNode (CTLNode phi, int i, CTLNode psi)
  {
    super (phi, psi);
    bound = i;
  }

  /**
   ** Gets the bound on the AUi.
   **/
  public int getI ()
  {
    return bound;
  }

  /**
   ** Sets the bound on the AUi.
   **/
  protected void setI (int i)
  {
    bound = i;
  }

  public String toString ()
  {
    return "A[" + getLeft () + " U" + bound + " " + getRight () + "]";
  }


  public void accept (CTLVisitor v, Object s)
  {
    v.visitAUiNode (this, s);
  }


}
