package edu.toronto.cs.experiments;

import java.util.List;
import java.util.Collection;
import java.util.Arrays;

public  class DigitDecoder extends Decoder {

    int base;
    int digits;

    public DigitDecoder(int base_, int digits_) {
	base = base_;
	digits = digits_;
    }
    public int numComponents() {
	return digits;
    }
    public  Object[] decode(Object inp) {
	int i = ((Integer)inp).intValue();
	Integer res[] = new Integer[digits];
	String str = Integer.toString(i, base);
	// pad with zeroes
	while (str.length() < digits)
	    str = new String("0"+str);

	for (int j=0; j<digits; j++)
	    res[j] = Integer.valueOf(str.substring(j, j+1), base);
	return res;
	
    }

    public int encode(int inp[]) {
	char inpArr[] = new char[inp.length];
	for (int i=0; i<inp.length; i++) {
	    inpArr[digits-i-1] = 
		Integer.toString(inp[i],
				 base).charAt(0);
	    
	    
	}
	return Integer.parseInt(new String(inpArr), base);
    }
    public static void main(String argv[]) {
	System.out.println("DigitDecoder running.");
    }
}

