package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import org.apache.log4j.*;

public class SparseInputBoolOutput extends SparseInputFunction {

    static Category log = 
	Category.getInstance("edu.toronto.cs.experiments.SparseInputBoolOutput");

    static {
	BasicConfigurator.configure();
    }

    public SparseInputBoolOutput(int m, int k, float sp, float dis) {
	super(m,k, sp, dis);
    }


    protected int fillRow(float disag) {
	// assume that disagreement is above threshold!
	if (Chaos.nextThreshold(sparsity))
	    return m-1;
	else return 0;
    }
    
    public Function clone (int m_, int k_) {
	return new SparseInputBoolOutput(m_, k_, sparsity, disTheta);
    }

    public static void main(String argv[]) {

	Function fn = new SparseInputBoolOutput(3,4, (float)0.1, (float)0.25);
	Iterator zoobert = fn.getAllPoints();
	while (zoobert.hasNext()) {
	    zoobert.next();
	}
    }
}
