package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import org.apache.log4j.*;

public abstract class SparseInputFunction extends TableFunction {

    static Category log = 
	Category.getInstance("edu.toronto.cs.experiments.SparseInputFunction");

    static {
	BasicConfigurator.configure();
    }

    float sparsity;
    float disTheta; // disagreement threshold

    public SparseInputFunction(int m, int k, float sp, float dis) {
	super(m,k);
	sparsity = sp;
	disTheta = dis;
	fill();
    }

    protected float disagreement (Object inp[]) {
	int p = 0;
	int foo[] = Function.objArrayToIntArray(inp);
	for (int i=0; i<inp.length; i++) 
	    if (!(foo[i] == 0 || foo[i] == (m-1)))
		p++;
	
	log.debug("Disag of "+Function.intArrayToString(foo)+" = "+ ((float)p/(float)k));
	return (float)p/
	    (float)k;
    }
    
    protected abstract int fillRow(float disag);
    
    protected void fill() {
	Object currInput[] = new Object [k];
	for (int i=0; i<table.length; i++) {
	    currInput = dec.decode(new Integer(i));
	    if (disagreement(currInput)>disTheta)
		table[i] =0;
	    else 
		table[i] = fillRow(disagreement(currInput));
	}
    }

//      public Function clone (int m_, int k_) {
//  	return new SparseInputFunction(m_, k_, sparsity, disTheta);
    //    }

    public static void main(String argv[]) {
	Chaos.seed(23);
	Function fn = new SparseFunction(3,4, (float)0.1);
	Iterator zoobert = fn.getAllPoints();
	while (zoobert.hasNext()) {
	    zoobert.next();
	}
    }
}



