package edu.toronto.cs.gui;

import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.tlq.*;
import edu.toronto.cs.smv.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;
import edu.toronto.cs.util.dgraph.*;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

import javax.swing.table.*;

/**
 * ImagePanel.java
 *
 *
 * Created: Wed Jun 26 13:58:59 2002
 *
 * @author <a href="mailto:anya@tallinn.cs">Tafliovich Anya</a>
 * @version
 */

public class ImagePanel extends JPanel {

  // the image  
  Image image;

  public ImagePanel (Image imageFile) {
    image = imageFile;
    if (image != null)
      setPreferredSize (new Dimension (image.getWidth(this),
				       image.getHeight(this)));
    setVisible(true);
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g); //paint background
    
    g.setFont(new Font (getFont().getFontName(), Font.BOLD, 12));
    

    //Draw image at its natural size,
    // if it exists; otherwise, display a text message
    if (image != null) 
      g.drawImage(image, 10, 10, this);
    else
      g.drawString ("No image available", 10, 100);
    
  }
  
}// ImagePanel
