package edu.toronto.cs.gui;

import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.tlq.*;
import edu.toronto.cs.smv.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;
import edu.toronto.cs.util.dgraph.*;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

import javax.swing.table.*;


public class LatticeElementListModel extends AbstractTableModel
{
  FiniteLattice lattice;
  java.util.List properties;
  java.util.List names;

  public LatticeElementListModel (FiniteLattice _lattice)
  {
    lattice = _lattice;
    properties = new ArrayList ();
    names = new ArrayList ();
  }
  
  public int getColumnCount ()
  {
    return properties.size ()+1;
  }
  
  public int getRowCount ()
  {
    return lattice.size ();
  }
  
  public Class getColumnClass (int columnIndex)
  {
    if (columnIndex == 0)
      return new String ().getClass ();

    Map l = (Map) properties.get (columnIndex-1);
    return l.get (lattice.getElementKeyByIdx (0)).getClass ();
    //return null;
  }
  
  
  public Object getValueAt (int row, int col)
  {
    if (col == 0)
      return lattice.getElementKeyByIdx (row).toString ();
    
    // Things are now interesting...
    Map l = (Map) properties.get (col-1);
    return l.get (lattice.getElementKeyByIdx(row));
  }
  
  public LatticeElementListModel addProperty (Map l)
  {
    return addProperty (l, null);
  }

  public LatticeElementListModel addProperty (Map l, String name)
  {
    properties.add (l);
    names.add (name);
    return this;
  }

  public boolean isCellEditable (int row, int column)
  {
    if (column == 0)
      return false;
    return true;
  }

  public void setValueAt (Object v, int row, int column)
  {
    if (column == 0)
      return;
    Map l = (Map) properties.get (column - 1);
    l.put (lattice.getElementKeyByIdx (row), v);
  }

  public String getColumnName (int column)
  {
    if (column == 0)
      return "T-Value:";
    String s = (String) names.get (column -1);
    if (s == null)
      return (((Map)properties.get (0)).get (lattice.getElementKeyByIdx (0))
	.getClass ()).toString ();
    return s;
  }
  
}

    
	

