package edu.toronto.cs.gui;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

/**
 ** The CTL output panel for our Model-Checker.
 **/
public class OutputPanel extends JPanel
{
  // text field
  JTextArea output;
  // scrolling capability
  JScrollPane scroll;

  public OutputPanel ()
  {
    // text field
    output = new JTextArea ("Welcome to XChek!\n", 15, 30);
    output.setEditable (false);
    output.setLineWrap (true);
    output.setWrapStyleWord (true);
    output.setFont (new Font ("Serif", Font.PLAIN, 18));
    // scrolling capability
    scroll = new JScrollPane 
      (output,
       JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
       JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

    setLayout (new BoxLayout (this, BoxLayout.Y_AXIS));
    setBorder (BorderFactory.createTitledBorder
	       (BorderFactory.createCompoundBorder
		(BorderFactory.createEtchedBorder (),
		 StandardFiller.makeEmptyBorder ()), "Output"));
    add (scroll);
  }

  /**
   ** Appends the string to the existing output.
   **/
  public void append (String str)
  {
    output.append (str);
    output.setCaretPosition (output.getText ().length ());
  }
}
