package edu.toronto.cs.keg;

import java.util.*; // We all love java.util ...

import edu.toronto.cs.ctl.*;
import edu.toronto.cs.util.dgraph.*;


public class KEGCtlNode extends DGUniqueNode implements KEGNode
{
  boolean terminal=false;
  Set states;
  Map childrenByCtl;
  CTLNode ctl;
  
  protected KEGCtlNode (CTLNode _ctl, Set _states, 
			KEGCtlNodeFactory _manager)
    {
      this (_ctl, _manager);
      makeTerminal (_states);
    }

  protected KEGCtlNode (CTLNode _ctl, KEGCtlNodeFactory _manager)
    {
      // XXX ouch...
      super (null, _manager);
      states = new HashSet ();
      ctl = _ctl;
    }

  public Set getStates ()
  {
    return states;
  }

  public Object getName ()
  {
    return ctl;
  }

  public void addNewSuccessor (CTLNode _ctl)
    {
      add (((KEGCtlNodeFactory)owner).createNode (_ctl));
    }

  public void addNewSuccessor (CTLNode _ctl, Set states)
    {
      add (((KEGCtlNodeFactory)owner).createNode (this, _ctl, states));
    }
  
  public CTLNode getCTL()
    {
      return ctl;
    }
  
  public void makeTerminal (Set _states)
    {
      terminal=true; 
      states=_states;
    }

  //public KEGCtlNodeFactory getFactory ()
  //  {
  //    return ((KEGCtlNodeFactory)super.getFactory());
  //  }

  public boolean isTerminal ()
    {
      return terminal;
    }

  public boolean checkValid(DGNode node)
    {
      return super.checkValid(node) && (node instanceof KEGCtlNode);
    }

  // -- Victor: I need this in order to have a nice way of making a generic
  // -- user prompt for the next choice.
  /**
   ** Converts the DGNode to a String.
   **/
  public String toString ()
  {
    String str = ctl.toString ();
    
    if (edgeData.size () > 0) // if there are edges from this node, show them
      {
	// -- Victor: need a better way of handling this....more informative
	str += " with some edges going out";	
      }

    return str;
  }
  
  public void accept (KEGraphVisitor visitor, Object stateinfo)
  {
    visitor.visitKCtlNode (this, stateinfo);
  }

}

















