package edu.toronto.cs.prettygraph;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;

public class PrettyGraphEdge extends DGEdge 
  implements PrettyGraphEdgeVisitable
{
  static Logger log = new Logger ("PrettyGraphEdge");
  
  
  String name = "";
  String type = "";
  String label = "";
  String fontfam = "";
  String fontstyle = "";
  Object colour = "";
  int lineThickness = 0;
  int lineNum = 0;
  int lineSolidity = 0;
  boolean directed = false;
  int arrowUp = 0;
  int arrowDown = 0;

  public PrettyGraphEdge (PrettyGraphNode origin, PrettyGraphNode destination)
  {
    super (origin, destination);
    log.debug ("Setting up with origin "+origin);
    log.debug (" dest "+destination);
    
    name = ((PrettyGraphNode)origin).getName () 
      + PrettyConstants.EDGE_CONNECT + ((PrettyGraphNode)destination).getName (); 
  }

  public PrettyGraphEdge setFontFamily (String s)
  {
    fontfam = s;
    return this;
  }
  
  public String getFontFamily ()
  {
    return fontfam;
  }
  
  public PrettyGraphEdge setFontStyle (String s)
  {
    fontstyle = s;
    return this;
  }
  
  public String getFontStyle ()
  {
    return fontstyle;
  }
  

  public PrettyGraphEdge setColour (Object _colour)
  {
    colour = _colour;
    return this;
  }
  
  public Object getColour ()
  {
    return colour;
  }
  
  public PrettyGraphEdge setLineNum (int _lineStyle)
  {
    lineNum = _lineStyle;
    return this;
  }
  
  public int getLineNum ()
  {
    return lineNum;
  }

  public PrettyGraphEdge setLineThickness (int _lineStyle)
  {
    lineThickness = _lineStyle;
    return this;
  }
  
  public int getLineThickness ()
  {
    return lineThickness;
  }

  public PrettyGraphEdge setLineSolidity (int _lineStyle)
  {
    lineSolidity = _lineStyle;
    return this;
  }
  
  public int getLineSolidity ()
  {
    return lineSolidity;
  }

  public String getType ()
  {
    return type;
  } 

  public PrettyGraphEdge setType (String _type)
  {
    type = _type;
    return this;
  }

  public PrettyGraphEdge setDirected (boolean b)
  {
    directed = b;
    return this;
  }
  
  public boolean isDirected ()
  {
    return directed;
  }
  
  public PrettyGraphEdge setArrowUp (int i)
  {
    arrowUp = i;
    return this;
  }
  
  public int getArrowUp ()
  {
    return arrowUp;
  }
  
  public PrettyGraphEdge setArrowDown (int i)
  {
    arrowDown = i;
    return this;
  }
  
  public int getArrowDown ()
  {
    return arrowDown;
  }

  public PrettyGraphEdge setLabel (String s)
  {
    label = s;
    return this;
  }
  
  public String getLabel ()
  {
    return label;
  }

  public PrettyGraphEdge setName (String _name)
  {
    name = _name;
    return this;
  }

  public String getName ()
  {
    return name;
  }
  
  public void accept (PrettyGraphEdgeVisitor visitor, Object stateinfo)
  {
    visitor.visitPrettyGraphEdge (this, stateinfo);
  }
  

}







