package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.mdd.*;

public class PrettyGraphMDDNode extends PrettyGraphNode
{
  static Logger log = new Logger (PrettyGraphMDDNode.class.getName ());
  
  MDDNode mdd = null;
  
  public PrettyGraphMDDNode (Object _label, DGlobalUniqueFactory _factory)
  {
    super (_label, _factory);
  }

  public void add (PrettyGraphMDDNode node, int i)
  {
    if (!successors.contains (node))
      super.add (node);
    DGMultiEdge edges = (DGMultiEdge) edgeData.get (node);
    edges.addSubEdge (new PrettyGraphMDDEdge (this, node, i));
    //System.out.println ("Adding edge of " + i + " from " + this
    //		+ " to " + node);
    edgeData.put (node, edges);
    /*
    if (successors.contains (node))
      ((PrettyGraphMDDEdge)getEdge (node)).addMulti (i);
    else
      super.add (node, new PrettyGraphMDDEdge (this, node, i));
    */
  }
  
  public PrettyGraphMDDNode setMDD (MDDNode _mdd)
  {
    mdd = _mdd;
    return this;
  }

  public void setupEdge (DGNode successor)
  {
    log.debug ("Setting up multiedge for "+successor);
    // XXX Hack. Makes it work?
    if (edgeData.get (successor) == null)
      {
	log.debug ("multiedge Actually doing so");
	edgeData.put (successor, new DGMultiEdge (this, successor));
      }
    
  }

  public MDDNode getMDD ()
  {
    return mdd;
  }

  public void accept (PrettyGraphVisitor visitor, Object stateinfo)
  {
    visitor.visitPrettyGraphMDDNode (this, stateinfo);
  }

}


