package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;

/**
 * DVGraphNode.java352
 *
 *
 * Created: Fri Jul 13 19:13:51 2001
 *
 * @author <a href="mailto:cdtw@tallinn.cs.toronto.edu">Christopher Thompson-Walsh</a>
 * @version
 */

public class PrettyGraphNode extends DGUniqueNode implements PrettyGraphNodeVisitable
{
  static Logger log = new Logger ("PrettyGraphNode");
  //DVNodeAttributes attributes=null;
  String type = "";
  Object name = null;
  Object label = "";
  Object colour = "";
  String textColour = "";
  int shape = 0;
  int lineNum = 0;
  int lineSolidity = 0;
  int lineThickness = 0;
  boolean hiddenToStart = false;
  String fontfamily = "";
  String fontstyle = "";
  String graphicname = "";
  

  protected PrettyGraphNode (Object _name, DGlobalUniqueFactory owner)
  {
    super (owner);
    //attributes = _a;
    setName (_name);
  }

  public PrettyGraphNode setColour (Object _colour)
  {
    colour = _colour;
    return this;   
  }
  
  public Object getColour ()
  {
    return colour;
  }
 public PrettyGraphNode setTextColour (String _colour)
  {
    textColour = _colour;
    return this;   
  }
  
  public String getTextColour ()
  {
    return textColour;
  }

  public PrettyGraphNode setShape (int s)
  {
    shape = s;
    return this;   
  }

  public int getShape ()
  {
    return shape;
  }
  
  public PrettyGraphNode setLineNum (int _lineStyle)
  {
    lineNum = _lineStyle;
    return this;   
  }
  
  public int getLineNum ()
  {
    return lineNum;
  }

  public PrettyGraphNode setLineThickness (int _lineStyle)
  {
    lineThickness = _lineStyle;
    return this;   
  }
  
  public int getLineThickness ()
  {
    return lineThickness;
  }

  public PrettyGraphNode setLineSolidity (int _lineStyle)
  {
    lineSolidity = _lineStyle;
    return this;   
  }

  public PrettyGraphNode setHiddenToStart (boolean b)
  {
    hiddenToStart = b;
    return this;
    
  }
  
  public boolean getHiddenToStart ()
  {
    return hiddenToStart;
  }
  
  public int getLineSolidity ()
  {
    return lineSolidity;
  }
  
  public PrettyGraphNode setFontFamily (String s)
  {
    fontfamily = s;
    return this;   
  }
  
  public String getFontFamily ()
  {
    return fontfamily;
  }

  public PrettyGraphNode setFontStyle (String s)
  {
    fontstyle = s;
    return this;   
  }
  
  public String getFontStyle ()
  {
    return fontstyle;
  }
  
  public PrettyGraphNode setGraphicName (String s)
  {
    graphicname = s;
    return this;   
  }
  
  public String getGraphicName ()
  {
    return graphicname;
  }
  
  /**
   * Get the value of type.
   * @return value of type.
   */
  public String getType () 
  {
    return type;
  }
  
  /**
   * Set the value of type.
   * @param v  Value to assign to type.
   */
  public PrettyGraphNode setType (String _type) 
  {
    type = _type;
    return this;
  }
  

  public Object getName ()
  {
    return name;
  }

  public PrettyGraphNode setName (Object _name) // Not really public
  {
    name = _name;
    return this;
  }

  public PrettyGraphNode setLabel (Object s)
  {
    label = s;
    return this;
  }
  
  public Object getLabel ()
  {
    return label;
  }

  // Overides method in DGUnique node. This causes the factory to
  // ensure uniqueness based on String name.
  public Object getIdent ()
  {
    return name;
  }

  // XXX Note to self: turn setupEdge into regular factory method and
  // make everything saner
  public void add (PrettyGraphNode node, PrettyGraphEdge edge)
  {
    super.add (node);
    getChildMap ().put(node.getIdent (), node);
    edgeData.put (node, edge);
  }

  // NNN Note to self: make this normal.
  public void setupEdge (DGNode successor)
  {
    // Do nothing. We want the edge to be specified by the user.
  }
 
  public void accept (PrettyGraphVisitor visitor, Object stateinfo)
  {
    log.debug ("Hi! -- PGN being visited by PGV");
    visitor.visitPrettyGraphNode(this, stateinfo);
  }

} // DVGraphNode
  
















