package edu.toronto.cs.prettygraph;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.xkripke.*;

public class PrettyKegEdge extends PrettyGraphEdge
{
  static Logger log = new Logger ("PrettyKegEdge");

  DGEdge kegedge;
  
  public PrettyKegEdge (PrettyKegGraphNode origin, 
			PrettyKegGraphNode destination, DGEdge _kegedge)
  {
    super (origin, destination);
    log.debug ("setting up with kegedge "+ _kegedge);
    setKegEdge (_kegedge);
  }
  

  /**
   * Get the value of kegedge.
   * @return value of kegedge.
   */
  public DGEdge getKegEdge() 
  {
    return kegedge;
  }

  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();
    sb.append ("PrettyKegEdge");
    sb.append (kegedge);
    sb.append ("-D");
    return sb.toString ();
  }
  
  /**
   * Set the value of kegedge.
   * @param v  Value to assign to kegedge.
   */
  public PrettyKegEdge setKegEdge(DGEdge  v) 
  {
    this.kegedge = v;
    return this;
  }
  
  public void accept (PrettyGraphEdgeVisitor visitor, Object stateinfo)
  {
    visitor.visitPrettyKegEdge (this, stateinfo);
  }
  
  
}








