package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.dgraph.*;


public class PrettyKegGraphNode extends PrettyGraphNode
{
  DGNode kegnode;

  public PrettyKegGraphNode (String _name, DGlobalUniqueFactory owner)
  {
    super (_name, owner);
  }

  PrettyKegGraphNode kegowner;
  
  /**
   * Get the value of owner.
   * @return value of owner.
   */
  public PrettyKegGraphNode getOwner() {
    return kegowner;
  }
  
  /**
   * Set the value of owner.
   * @param v  Value to assign to owner.
   */
  public PrettyKegGraphNode setOwner (PrettyKegGraphNode  v) {
    this.kegowner = v;
    return this;
  }  

  public PrettyKegGraphNode setKegNode (DGNode _kegnode)
  {
    kegnode =_kegnode;
    return this;
  }
  
  public DGNode getKegNode ()
  {
    return kegnode;
  }

  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();
    sb.append (this.getClass ());
    sb.append (" with kegnode: ");
    sb.append (""+getKegNode ());
    sb.append ('\n');
    return sb.toString ();
  }

  public void accept (PrettyGraphVisitor visitor, Object stateinfo)
  {
    visitor.visitPrettyKegGraphNode (this, stateinfo);
  }
  
}

  



