package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;
//import edu.toronto.cs.mvset.MvState;
import edu.toronto.cs.algebra.*;
import edu.toronto.cs.modelchecker.*;

public class PrettyMDDEdgeColouring extends PrettyGraphEdgeVisitorAncestor
{
  static Logger log = new Logger (PrettyMDDEdgeColouring.class.getName ());

  Map colourmap;
  Algebra lattice;
  PropOrderIf prop;
  
  public PrettyMDDEdgeColouring (PropOrderIf _prop, Map _colourmap, 
				 Algebra _lattice)
  {
    prop = _prop;
    lattice = _lattice;
    colourmap = _colourmap;
  }

  public void visitPrettyGraphMDDEdge (PrettyGraphMDDEdge edge)
  {
    //edge.setLabel (""+lattice.getElementKeyByIdx (edge.getValue ()));
    if (colourmap.get 
	(lattice.getElementKeyByIdx (edge.getValue ())) != null)
      edge.setColour 
	(""+colourmap.get 
	 (lattice.getElementKeyByIdx (edge.getValue ())));
    else
      edge.setColour ("black");
  }
  
}



