package edu.toronto.cs.util.dgraph;

import java.util.*;

import edu.toronto.cs.util.*;

public class DGEdgeVisitorAncestor implements DGEdgeVisitor
{
  static Logger log = new Logger ("DGEdgeVisitorAncestor");
  

  public DGEdgeVisitorAncestor ()
  {
  }
  
  public void visit (DGEdgeVisitable edge, Object stateinfo)
  {  
    edge.accept (this, stateinfo);
  }
  

  public void visitDGEdge (DGEdge edge, Object stateinfo)
  {
  }

  // Note: this method causes, in general, edge visitors to behave in
  // an intuitive but non obvious manner. Specifically, a visitor will
  // visit each edge in a multiedge, as if it were a regular full
  // fledged edge, even though in structural "reality" it is simply a
  // child of the multiedge...
 public void visitDGMultiEdge (DGMultiEdge edges, Object stateinfo)
  {
    log.debug ("Visit multiedge; "+ edges.getValues ().size () + "subedges");
    for (Iterator it = edges.getSubEdges (); it.hasNext ();)
      {
	visit ((DGEdge)it.next (), stateinfo);
      }
  }

}



