package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...
import edu.toronto.cs.util.*;

public class DGHistorian extends DGraphVisitorAncestor 
  implements DGStateInfoSource
{
  protected Map nodeToPedigree;

  public DGHistorian ()
  {
    nodeToPedigree = new HashMap ();
  }

  public void visitDGNode (DGNode node, Object stateinfo)
  {
    // This makes sure that even the rootnodes get entries...
    if (!nodeToPedigree.containsKey (node))
	nodeToPedigree.put (node, new ArrayList ());

    // Go through, and add this node's pedigree to each of its children's pedigree
    for (Iterator it = node.getSuccessors ().iterator (); it.hasNext ();)
      {
	DGNode nnode = (DGNode) it.next ();
	if (!nodeToPedigree.containsKey (nnode))
	  nodeToPedigree.put (nnode, new ArrayList ());
	List l = (List) nodeToPedigree.get (nnode);
	l.addAll ((List)nodeToPedigree.get (node));
	l.add (node);
      }
    
  }

  public void visitDGUniqueNode (DGUniqueNode node, Object stateinfo)
  {
    visitDGNode (node, stateinfo);
  }  
  

  public Map getPedigreeMap ()
  {
    return nodeToPedigree;
  }
  
  public Object getStateInfo (DGNode node)
  {
    return nodeToPedigree.get (node);
  }
  
}




