package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...
import edu.toronto.cs.util.*;

// NOTE: This visitor requires a BREADTH FIRST traversal...
// NOTE: This visitor will fail on graphs which are not trees.
public class DGTreeRanger extends DGHistorian
{
  public Map nodeToIndex;

  public DGTreeRanger ()
  {
    nodeToIndex = new HashMap ();
  }

  public void visitDGNode (DGNode node, Object stateinfo)
  {
    super.visitDGNode (node, stateinfo);
    // System.out.println ("Hi, I'm being run.");
    // This makes sure that even the rootnodes get entries...
    if (!nodeToIndex.containsKey (node))
	nodeToIndex.put (node, new Integer (0));
    int currentIndex = ((Integer)nodeToIndex.get (node)).intValue ();
    currentIndex++;
    for (Iterator it = node.getSuccessors ().iterator (); it.hasNext ();)
      {
	DGNode nnode = (DGNode) it.next ();
	nodeToIndex.put (nnode, new Integer (currentIndex));
      }
    
  }

  public void visitDGUniqueNode (DGUniqueNode node, Object stateinfo)
  {
    visitDGNode (node, stateinfo);
  }  

  public Object getStateInfo (DGNode node)
  {
    List l = new LinkedList ();
    l.add (nodeToPedigree.get (node));
    l.add (nodeToIndex.get (node));
    return l;
  }
}

